/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 22, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coreservices.searchkit.SKSummary;

//import dstep.AvailabilityMacros;
import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFString;

struct __SKSummary;

alias __SKSummary* SKSummaryRef;

extern (C)
{
	uint SKSummaryGetTypeID ();
	SKSummaryRef SKSummaryCreateWithString (CFStringRef inString);
	int SKSummaryGetSentenceCount (SKSummaryRef summary);
	int SKSummaryGetParagraphCount (SKSummaryRef summary);
	CFStringRef SKSummaryCopySentenceAtIndex (SKSummaryRef summary, int i);
	CFStringRef SKSummaryCopyParagraphAtIndex (SKSummaryRef summary, int i);
	CFStringRef SKSummaryCopySentenceSummaryString (SKSummaryRef summary, int numSentences);
	CFStringRef SKSummaryCopyParagraphSummaryString (SKSummaryRef summary, int numParagraphs);
	int SKSummaryGetSentenceSummaryInfo (SKSummaryRef summary, int numSentencesInSummary, CFIndex* outRankOrderOfSentences, CFIndex* outSentenceIndexOfSentences, CFIndex* outParagraphIndexOfSentences);
	int SKSummaryGetParagraphSummaryInfo (SKSummaryRef summary, int numParagraphsInSummary, CFIndex* outRankOrderOfParagraphs, CFIndex* outParagraphIndexOfParagraphs);
}